// California Individual-based Fish Simulation System. 
// Copyright (C) 1999 Lang Railsback & Assoc.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import <objc/objc-api.h>
#import <objectbase.h>
#import <simtools.h>
#import <analysis.h>
#import <activity.h>
#import <collections.h>
#import "TemplateBatchSwarm.h"

// First, the interface for the ParameterManager

@interface ParameterBatchManager: Swarm {

  int modelIterator;

}

- (BOOL) canWeGoAgain;

@end


@interface ExperBatchSwarm: Swarm
{
  int numExperimentsRun;
  id <Zone> experZone;
  id <Zone> aScenarioZone;

  id experSchedule;
  id testSchedule;

  TemplateBatchSwarm * subSwarm;

  id * modelSwarm;
  id <List> experClassList;
  id <ListIndex> experClassNdx;

  ParameterBatchManager *parameterManager;

  id <Activity> subswarmActivity;

}

+ createBegin: aZone;
- createEnd;
- setupModel;
- buildModel;
- runModel;
- dropModel;
- checkToStop;

- buildObjects;
- buildActions;
- activateIn: swarmContext;

- go;
@end




