// California Individual-based Fish Simulation System. 
// Copyright (C) 1999 Lang Railsback & Assoc.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import <objc/objc-api.h>
#import <simtoolsgui/GUISwarm.h>
#import <objectbase/SwarmObject.h>
#import <objectbase.h>
#import <analysis.h>
#import <analysis/EZGraph.h>
#import "TemplateObserverSwarm.h"

// First, the interface for the ParameterManager

@interface ParameterManager: SwarmObject {

  int modelIterator;


}

- (BOOL) canWeGoAgain;

@end





@interface ExperSwarm: GUISwarm
{

  id experZone;
  id aScenarioZone;

  int numExperimentsRun;

  id dynRunGroup;
  id testRunGroup;

  id experSchedule;
  id testSchedule;

  TemplateObserverSwarm * subSwarm;
  id <ActivityControl> subSwarmControl;

  id * modelSwarm;
  id <List> experClassList;
  id <ListIndex> experClassNdx;

  ParameterManager *parameterManager;

  id <Activity> subswarmActivity;

  id <ProbeMap> modelProbeMap;

}

+ createBegin: aZone;
- createEnd;
- setupModel;
- buildModel;
- runModel;
- dropModel;
- checkToStop;

- buildObjects;
- buildActions;
- activateIn: swarmContext;

@end




