// Template application. Copyright  1996-1999 Santa Fe Institute.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import "TemplateBatchSwarm.h"
#import <simtools.h>

// implementation of sample graphical interface for models.
@implementation TemplateBatchSwarm

+ createBegin: aZone
{
  TemplateBatchSwarm * obj;
  
  obj = [super createBegin: aZone];

  // MODIFY: initialize other batch options here.
  //obj->batchFrequency = 10000;
  obj->batchFrequency = 1;


  return obj;
}

// MODIFY: possible creation finalization here
- createEnd
{
  return [super createEnd];
}

- objectSetup {
  //fprintf(stderr,"TEMPLATEBATCHSWARM >>>>> objectSetup\n");
  //fflush(0);

  templateModelSwarm = [TemplateModelSwarm create: self];
  [templateModelSwarm objectSetup];


  return self;

}

- buildObjects
{
  //[super buildObjects];
  

  [templateModelSwarm buildObjects];

  // MODIFY: build batch objects here.
  observedCounter = [templateModelSwarm getCounter];
  
  return self;
}  

- buildActions
{
  [super buildActions];
  
  [templateModelSwarm buildActions];

  // MODIFY: schedule batch objects here.
  batchActions = [ActionGroup create: self];
  //[batchActions createActionTo: observedCounter     message: M(print)];
  [batchActions createActionTo: self         message: M(checkToStop)];

  batchSchedule = [Schedule createBegin: self];
  [batchSchedule setRepeatInterval: batchFrequency];
  batchSchedule = [batchSchedule createEnd];
  [batchSchedule at: 0 createAction: batchActions];

  return self;
}  

- activateIn: swarmContext
{
  [super activateIn: swarmContext];

  modelActivity = [templateModelSwarm activateIn: self];
  [batchSchedule activateIn: self];
  
  return [self getSwarmActivity];
}

- getModelSwarm {

  return templateModelSwarm;

}

- getModelZone {

  return [templateModelSwarm getModelZone];

}


- setModelNumberTo: (int) aNumber {

  modelNumber = aNumber;

  return self;
}


- checkToStop {

  if ( [templateModelSwarm whenToStop] == YES ) {
    finished = YES;
   
    modelActivity = nil;

    [[self getActivity] stop];
 
   //fprintf(stderr,"\nStop date achieved\n");
   //fflush(0);

  }


return self;
}



- (BOOL) areYouFinishedYet {

  return [templateModelSwarm whenToStop];

}


- (void) drop {
[batchActions drop];
batchActions = nil;
if(templateModelSwarm)
    [templateModelSwarm drop];
templateModelSwarm = nil;

}
@end
