// Template application. Copyright  1996-1999 Santa Fe Institute.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import "TemplateModelSwarm.h"

// Implementation of the model for template.

#define STRSIZE 100000
#define SIZE STRSIZE*sizeof(char)
//#define SIZE 20
//#define SIZE 100000*sizeof(double);
//#define SIZE sizeof(double);

@implementation TemplateModelSwarm

-(Counter *) getCounter {
  return counter;
}

+create: (id) aZone {
  TemplateModelSwarm * obj;

  //fprintf(stderr,"TEMPLATEMODELSWARM >>>> createBegin...\n");
  //fflush(0);

  obj = [super create: aZone];

  // MODIFY: add in defaults for your simulation parameters.
  obj->increment = 1;
  obj->stopCount = 3;

  return obj;
}

// MODIFY: possible creation objects here.
- createEnd 
{
  return [super createEnd];
}



/////////////////////////////////////////////////////
//
// objectSetup
//
/////////////////////////////////////////////////////
- objectSetup {

  modelZone = [Zone create: [self getZone]];

  //printMyHello = "Default hello message";

  counter = [Counter create: modelZone];
  [counter setIncr: increment];


  return self;
}


- buildObjects 
{
  //int i;
  [super buildObjects];

  //fprintf(stderr,"SCENARIO = %d REPLICATE = %d \n", scenario, replicate);
  //fflush(0);

/*
  for(i=0;i<500;i++) {

    someStrings[i] = "I am a String .................................";

  }
 */ 




  // MODIFY: create your simulation objects and set them up from the
  // model parameters.

  return self;
}

- buildActions 
{
  [super buildActions];

  // MODIFY: schedule your own agents as appropriate.
  modelActions = [ActionGroup create: self];
  [modelActions createActionTo: counter message: M(step)];

  [modelActions createActionTo: self message: M(printMyHelloMessage)];

  modelSchedule = [Schedule createBegin: self];
  [modelSchedule setRepeatInterval: 1];
  modelSchedule = [modelSchedule createEnd];
  [modelSchedule at: 0 createAction: modelActions];

  return self;
}

- activateIn:  swarmContext 
{
  [super activateIn: swarmContext];

  [modelSchedule activateIn: self];

  return [self getSwarmActivity];
}

- printMyHelloMessage {
int i;
  //fprintf(stdout, "printMyHello = %s scenario = %d replicate = %d\n", printMyHello,
                                                                      //scenario,
                                                                      //replicate);
  //fflush(stdout);

  for(i=0; i< 1; i++) ;
  return self;
}


- getModelZone {

  return modelZone;

}

- (BOOL) whenToStop {
  //int i=0;
  //int j =0;


     //myDouble2 = (double **) [ZoneAllocMapper allocBlockIn: modelZone ofSize: 100 * sizeof(double*)];  

//for(i=0;i<100;i++) {

     //myDouble2[i] = (double *) [ZoneAllocMapper allocBlockIn: modelZone ofSize: 100 * sizeof(double)];  

     //for(j=0;j<100;j++) {

     //myDouble2[i][j] = 1.23*i*j;

  //}
//}


   stop = NO;


   if ([counter getValue] >= stopCount) {

       stop = YES;

   }

return stop;

}


- (void) drop {

  [modelActions drop];

  [counter drop];
  [modelZone drop];
  modelZone = nil;
  [super drop];

}

@end
